function SearchTools(){
  this.parseGoogleImgSearchResponse=null;
}

var searchTools = new SearchTools();


searchTools.parseGoogleImgSearchResponse = function (html) {
    var result = [];
    try {
        var re = /"b-GRID_STATE0"[^\[]+\["GRID_STATE0"[^\[]+(\[(.|\a|\n)*)/i; // look for [ after "b-GRID_STATE0" ...["GRID_STATE0" and take the rest till the last ]
        var prepText = html.match(re);
        var larray = undefined;

        if (prepText && (prepText.length > 1)) {
            prepText = prepText[1];
            // we have deeply nested array and ending from upper arrays, cut only first array with all nested parts
            var level = 1;
            var l = prepText.length;
            var ch;
            var idx = 1;
            var lastBegin = -1;
            larray = [];
            var insideQuotes = false;
            while ((level > 0) && (idx < l) && (larray.length < 50)) { // take only the first 50 results
                ch = prepText.charAt(idx);
                if (!insideQuotes) {
                    if (ch === '[') {
                        level++;
                        if (level === 2)
                            lastBegin = idx;
                    } else if (ch === ']') {
                        level--;
                        if (level === 1) {
                            var addStr = prepText.substring(lastBegin, idx + 1);
                            if (addStr.charAt(1) === '1') { // it seems other numbers like 2 is not search result we want
//                                ODS('Adding item ' + (larray.length + 1) + ': ' + addStr);
                                larray.push(addStr);
//                                ODS('Added item ' + larray.length);
                            }
                        }
                    }
                }
                if ((ch === '"') && (prepText.charAt(idx - 1) !== '\\')) {
                    insideQuotes = !insideQuotes;
                }
                idx++;
            }
        }
        if (!larray) {
            if(NotifyDebug)
                NotifyDebug('rSuccessGoogle: larray is NULL');
        }
        else {
            if(NotifyDebug)
                NotifyDebug('rSuccessGoogle: going to fill ' + larray.length + ' results');
            for (var i = 0; i < larray.length; i++) {
                var itemStr = larray[i];
//                ODS('Parsing result ' + (i+1) + ', ' + itemStr);
                var item = JSON.parse(itemStr);
                if(item) {
                    item = item[1];
                    if(item && item[3]) {
                        var res = {};
                        res.imglink = decodeURIComponent(decodeURIComponent(item[3][0])); // some links are double encoded, see mantis #13047 for details
                        res.width = item[3][1];
                        res.height = item[3][2];
                        res.thumblink = decodeURIComponent(item[2][0]);
                        result.push(res);
                    }
                }
            }
        }
    } catch (ex) {
        if(NotifyDebug)
            NotifyDebug(ex.message);
    }
    return result;
}